// MP3reFormaterDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "MP3reFormater.h"
#include "MP3reFormaterDlg.h"
#include "TaskDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMP3reFormaterDlg Dialogfeld

CMP3reFormaterDlg::CMP3reFormaterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMP3reFormaterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMP3reFormaterDlg)
	extensions = _T("mp3");
	makeUpper = TRUE;
	correctSpacings = TRUE;
	includeSubdirs = TRUE;
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMP3reFormaterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMP3reFormaterDlg)
	DDX_Control(pDX, IDC_DIR_LIST, dirList);
	DDX_Text(pDX, IDC_EXTENSIONS, extensions);
	DDX_Check(pDX, IDC_MAKE_UPPER, makeUpper);
	DDX_Check(pDX, IDC_CORRECT_SPACINGS, correctSpacings);
	DDX_Check(pDX, IDC_INCLUDE_SUBDIRS, includeSubdirs);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMP3reFormaterDlg, CDialog)
	ON_WM_DROPFILES()
	//{{AFX_MSG_MAP(CMP3reFormaterDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_REFORMAT, OnReformat)
	ON_BN_CLICKED(ID_ABOUT, OnInfoClick)
	ON_BN_CLICKED(ID_CLEAR_LIST, OnClearList)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMP3reFormaterDlg Nachrichten-Handler

BOOL CMP3reFormaterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen
	
	DragAcceptFiles();

	CBitmap bmp;
	bmp.LoadBitmap(IDB_FOLDER);

	imageList.Create(16,16,ILC_COLOR4,0,1);
	imageList.Add(&bmp,RGB(0,0,0));

	dirList.SetImageList(&imageList,LVSIL_NORMAL);
	dirList.SetImageList(&imageList,LVSIL_SMALL);
	dirList.SetImageList(&imageList,LVSIL_STATE);

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CMP3reFormaterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CMP3reFormaterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CMP3reFormaterDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

afx_msg void CMP3reFormaterDlg::OnDropFiles(HDROP hDrop)
{
//	dirList.DeleteAllItems();
	
	//Anzahl an Dateien
	int count = DragQueryFile(hDrop,0xFFFFFFFF,0,0);
	char buffer[512];
	CFileStatus status;
	CFile file;

	int n = dirList.GetItemCount();

	for (int i = 0; i < count; i += 1)
	{
		DragQueryFile(hDrop,i,buffer,512);
		
		CFile::GetStatus(buffer,status);
		
		if (((status.m_attribute & directory) == directory))
		{
			file.Open(buffer,CFile::modeRead);

			//to dirlist : only filename 
			dirList.InsertItem(n,file.GetFileName(),0);

			//to dirs array: full path
			dirs.Add(CString(buffer));

			n++;
		}
		
	}
}

void CMP3reFormaterDlg::OnReformat() 
{
	UpdateData();

	extensions.MakeLower();

	if ( dirs.GetSize() == 0)
		return;

	if (!correctSpacings && !makeUpper)
	{
		CString string;
		string.LoadString(IDS_SENSE);

		MessageBox(string,"MP3reFormater",MB_ICONQUESTION | MB_OK);

		return;
	}
		
	
	CTaskDialog task;
	
	task.SetParentDlg(this);

	//let's do the job!!
	task.DoModal();
}

void CMP3reFormaterDlg::OnInfoClick() 
{
	CAboutDlg aboutBox;
	aboutBox.DoModal();
}

void CMP3reFormaterDlg::OnClearList() 
{
	dirList.DeleteAllItems();
	dirs.RemoveAll();
}

void CMP3reFormaterDlg::OnClose() 
{
	OnOK();
	
	CDialog::OnClose();
}
