// MP3reFormaterDlg.h : Header-Datei
//

#if !defined(AFX_MP3REFORMATERDLG_H__07031E95_1D0A_47EE_89E5_2DA7B0F5C25D__INCLUDED_)
#define AFX_MP3REFORMATERDLG_H__07031E95_1D0A_47EE_89E5_2DA7B0F5C25D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxtempl.h>

enum 
{
   normal =    0x00,
   readOnly =  0x01,
   hidden =    0x02,
   sys =    0x04,
   volume =    0x08,
   directory = 0x10,
   archive =   0x20
};

/////////////////////////////////////////////////////////////////////////////
// CMP3reFormaterDlg Dialogfeld

class CMP3reFormaterDlg : public CDialog
{
// Konstruktion
public:


	CMP3reFormaterDlg(CWnd* pParent = NULL);	// Standard-Konstruktor

	bool GetCorrectSpacings() { return correctSpacings; }
	bool GetIncludeSubdirs() { return includeSubdirs; }
	bool GetMakeUpper() { return makeUpper; }
	CArray<CString,CString&>& GetDirs() { return dirs; }
	CString& GetExtensions() { return extensions;}

// Dialogfelddaten
	//{{AFX_DATA(CMP3reFormaterDlg)
	enum { IDD = IDD_MP3REFORMATER_DIALOG };
	CListCtrl	dirList;
	CString	extensions;
	BOOL	makeUpper;
	BOOL	correctSpacings;
	BOOL	includeSubdirs;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CMP3reFormaterDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	afx_msg void OnDropFiles(HDROP hDrop);

	HICON m_hIcon;
	CArray<CString,CString&> dirs;
	CImageList imageList;



	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(CMP3reFormaterDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnReformat();
	afx_msg void OnInfoClick();
	afx_msg void OnClearList();
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_MP3REFORMATERDLG_H__07031E95_1D0A_47EE_89E5_2DA7B0F5C25D__INCLUDED_)
